local TheSim = GLOBAL.TheSim
local Vector3 = GLOBAL.Vector3
local SpawnPrefab = GLOBAL.SpawnPrefab

local function TrapComponentPostInit(self)
    function self:Harvest(doer)
        if self.issprung then
            self.inst:PushEvent("harvesttrap")
            if self.onharvest then
                self.onharvest(self.inst)
            end            
            local timeintrap = self.inst.components.timer and self.inst.components.timer:GetTimeElapsed("foodspoil") or 0
            if self.lootprefabs and doer.components.inventory then
                for k,v in ipairs(self.lootprefabs) do
                    local loot = SpawnPrefab(v)
                    if loot then
                        doer.components.inventory:GiveItem(loot, nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
                        if loot.components.perishable then
                            loot.components.perishable:LongUpdate(timeintrap)
                        end
                    end
                end
            end			
            self:Reset()						
            self.inst:PushEvent("ondropped") --< MOD			
        else  		
            if self.inst.components.finiteuses and self.inst.components.finiteuses:GetUses() > 0 then
                doer.components.inventory:GiveItem(self.inst, nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
            end --> MOD
        end
    end
	
	if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then	
		function self:OnTrappedStarve()
			if self.issprung then
				self.inst:PushEvent("harvesttrap")
				if self.onharvest then
					self.onharvest(self.inst)
				end
				
				local timeintrap = self.inst.components.timer and self.inst.components.timer:GetTimeElapsed("foodspoil") or TUNING.TOTAL_DAY_TIME * 2
				if self.starvedlootprefabs then
					for k,v in ipairs(self.starvedlootprefabs) do
						local loot = SpawnPrefab(v)
						if loot then
							loot.Transform:SetPosition(self.inst:GetPosition():Get())
							if loot.components.perishable then
								loot.components.perishable:LongUpdate(timeintrap)
							end
						end
					end
				end
				self:Reset()
				self.inst:PushEvent("ondropped") --< MOD
			end	
		end
	end
end

AddComponentPostInit("trap", TrapComponentPostInit)

